package utils

import (
	"fmt"
	"reflect"
)

func MergeMaps(destMap, sourceMap map[string]interface{}) map[string]interface{} {
	newMap := make(map[string]interface{})

	// 将目标 map 的元素复制到新 map 中
	for key, value := range destMap {
		newMap[key] = value
	}

	// 将源 map 中的元素合并到新 map 中
	for key, value := range sourceMap {
		newMap[key] = value
	}

	return newMap
}

func PrintStructFields(s interface{}) {
	v := reflect.ValueOf(s)
	if v.Kind() == reflect.Struct {
		t := v.Type()
		for i := 0; i < v.NumField(); i++ {
			fieldName := t.Field(i).Name
			fieldValue := v.Field(i).Interface()
			fmt.Printf("Key: %s, Value: %v\n", fieldName, fieldValue)
		}
	}
}
